		ВВЕДЕНИЕ.

Эти скрипты показывают пример как можно автоматически переименовать файлы 
восстановленные с помощью утилиты anysurrect.

Автоматическое переименование осуществляет программа 'anyrename'.
Алгоритм: вычисляется хеш функция файла и если есть совпадение хеша с каким-то
хешем с базы то файл переименовывается.

Чтобы всё это сработало нужно иметь базу данных имён файлов и хешей откуда можно
было бы вытянуть файл с данными типа:
	хеш файла	имя файла

Если у Вас нет какой-нибудь базы откуда можно было бы добыть эти данные, то
приведённый выше алгоритм для автоматического переименования файлов
не сработает, но тогда программа попытается переименовать некоторые типы файлов,
основываясь на данных, находящихся внутри файла. Конечно, правильность
переименования в этом случае никак не гарантируется.

Программа 'anyrenamemakedb' как раз показывает пример как имея какую-то базу
данных имен файлов и их хешей можно вытянуть с неё всю необходимую информацию
для переименования файлов.
Пока она поддерживает:
1) портадж (portage для пользователей Gentoo), для переименования файлов
с /usr/portage/distfiles.
2) /var/db/pkg (для пользователей Gentoo), для переименования файлов в /

Если вы пользовались какой-нибудь системой обнаружения вторжений, которая 
в своей внутренней базе сохранила необходимые данные или ваш менеджер пакетов 
при установке создаёт базу с необходимыми данными (имя файла и хеш файла), то
можно дописать скрипт 'anyrenamemakedb', который создаст файл данных необходимый
для восстановления имён.


		anyrename

Программа автоматического переименования файлов восстановленных с помощью
anysurrect. Она может работать в трёх режимах:

    1. В этом случае гарантируется корректность переименования
    файлов но для работы необходим файл данных (--datafile) типа:
	    ХЕШ_ФАЙЛА				ИМЯ_ФАЙЛА
	5e09b6a51a66dfee261fd39af105ec1f binkplayer-1.8h.zip
	c7a112eef6f59c4e9602cd4a9b3d9a31 pyslsk-1.2.7b.tar.gz
	4ea070732bd0658d34e58a361866987d vzctl-3.0.0-4.tar.bz2
    для оставшихся непереименованных файлов будет применён другой метод. 

	$ anyrename [--workdir=<рабочая директория>] [--hash=<хэш-функция>]
                    --mnt=<точка монтирования> --datafile=<файл данных>

	Опции:
	    -d	--datafile=<файл данных>
		файл данных.

	    -m	--mnt=<полный путь к точке монтирования>
		полный путь к точке монтирования восстанавливаемого
		устройства.

	    -w	--workdir=<полный путь к рабочему каталогу>
		полный путь к рабочему каталогу где создаётся журнал.
		(/tmp/anyrename)

	    --hash=<команда хеш-функции>
		команда которая вычисляет используемую в --datafile
		хеш-функцию. (md5sum)
	

    2. В случае отсутствия файла данных имён и хешей программа попытается
    переименовать некоторые типы файлов, основываясь на информации, находящейся
    внутри файла.
    Этот режим не гарантирует правильности переименования файлов, но
    это лучше, чем ничего.

	$ anyrename [--workdir=<рабочая директория>]
                    --mnt=<точка монтирования>

	Опции:
	    -m	--mnt=<точка монтирования>
		точка монтирования восстанавливаемого устройства.

	    -w	--workdir=<рабочий каталог>
		рабочий каталог, где создаётся журнал. (/tmp/anyrename)


    3. Режим тестирования. Тестирует способность anysurrect восстанавливать
    некоторый файл и затем пытается переименовать его.

	$ anyrename [--workdir=<рабочая директория>] [--types=<типы>]
                    --mnt=<тестовая директория> --testfile=<тестируемый файл>

	Опции:
	    -t	--testfile=<тестируемый файлу>
		тестируемый файлу.

	    -m	--mnt=<тестовая директория>
		каталог для переименования.

	    -w	--workdir=<рабочий каталог>
		рабочий каталог, где создаётся журнал. (/tmp/anyrename)

		--types=<типы>
		типы распознаваемых файлов. Передаётся с параметром -t anysurrect'у

	В случае не возможности переименования имя файла будет inode-test.


    И ещё один режим:

        $ anyrename [--help] [--version[

	Опции:
	    -h	--help
	    	выводит это сообщение (на английском) и прекращает работу.

	    -v	--version
	    	выводит версию программы и прекращает работу.



		anyrenamemakedb

Пример программы для создания файла данных (--datafile) необходимого для
работы 'anyrename'

Файл данных пока создаётся в следующих случаях:

    1. На основе базы данных portage дистрибутива Gentoo и
    может использоваться только для переименования файлов
    из каталога /usr/portage/distfiles

        $ anyrenamemakedb [--workdir=<рабочий каталог>]
		    [--datafile=<файл данных>] --portage=<директория portage>

	    -p	--portage=<директория portage>
		директория portage.

	    -w	--workdir=<рабочий каталог>
		рабочий каталог, где создаётся журнал. (/tmp/anyrenamemakedb)
	
	    -d	--datafile=<файл данных>
		Генерируемый файл данных. ($workdir/file_list)

	    --hash=<имя хеш-функции>
		имя хеш-функции используемой в файле file_path.
		(НЕ КОМАНДА!). ('MD5 ')


    2. Файл данных создаётся на основе базы данных установленных
    в системе пакетов программ с помощью менеджера portage дистрибутива Gentoo
    и может использоваться только, если сохранился каталог базы установленных 
    в системе пакетов: /var/db/pkg/. Также создаёт два скрипта, которые создают
    директории и символические ссылки. 

        $ anyrenamemakedb [--workdir=<рабочий каталог>]
		    [--datafile=<файл данных>] --gentoo=<pkg директория>

	    -g	--gentoo=<директория pkg>
		директория pkg.

	    -w	--workdir=<рабочий каталог>
		рабочий каталог, где создаётся журнал. (/tmp/anyrenamemakedb)
	
	    -d	--datafile=<файл данный>
		Генерируемый файл данных. ($workdir/file_list)


    3. Файл данных имен и хешей создается на основе существующего дерева
    каталогов.
    Этот режим скорее имеет демонстрационное и тестовое назначение.

        $ anyrenamemakedb [--workdir=<рабочий каталог>]
		    [--datafile=<файл данных>] --anydir=<директория>

	    -a	--anydir=<директория>
		Любая директория.

	    -w	--workdir=<рабочий каталог>
		полный путь к рабочему каталогу, где создаётся журнал.
		(/tmp/anyrenamemakedb)
	
	    -d	--datafile=<полный путь к файлу>
		полный путь к файлу данных. ($workdir/file_list)

	    --hash=<команда которая вычисляет хеш-функцию>
		команда которая вычисляет используемую в --datafile 
		хеш-функцию.(md5sum)


    И ещё один режим:

        $ anyrenamemakedb [--help] [--version[

	Опции:
	    -h	--help
	        выводит это сообщение и прекращает работу.

	    -v	--version
	        выводит версию программы и прекращает работу.
